<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>ExampleCherryPiWebsite</title>
    <link href="/css/main.css" rel="stylesheet">
    <script src = "https://ajax.googleapis.com/ajax/libs/angularjs/1.2.15/angular.min.js"></script>
</head>
<body>
<h1>CherryPi Website</h1>
<p>This is an example of a website with static and dynamic content</p>
<p>All the static files in the directory public are provided as static content (included the index)</p>
<p>
    The dynamic content is provided via methods in the app class annotated as @cherrypy.expose <br />
    They are accessible through the same root of the static ones, so they should be named to avoid conflicts
</p>

<h2>Visit a dynamically generated page with a random number</h2>
<form method="get" action="python_generated_page">
  length: <input type="text" value="8" name="length" />
  <button type="submit">generate</button>
</form>
</body>

<h2>AngularJs ajax and session</h2>

<div ng-app = "GeneratorApp" ng-controller = "generatorController" ng-init = "generated_string = 'generating...'; generatorGet();">
    <p>Generated string in session: <span ng-bind = "generated_string"></span></p>
    <p><button ng-click="generatorGet()">get current</button></p>
    <p><button ng-click="generatorPost()">generate new</button></p>
    <p><input type="text" ng-model = "toput"><button ng-click="generatorPut()">put</button></p>
    <p><button ng-click="generatorDelete()">delete</button></p>
</div>
<script>
var myApp = angular.module('GeneratorApp',[]);
 myApp.controller('generatorController', function($scope,$http) {
    var url = "/api/string_generator";
    var http_config = {
        //headers: {'Content-Type': 'text/plain;charset=utf-8'}
    }

    $scope.generatorGet = function() {
        $http.get(url, http_config).then( function(response) {
            $scope.generated_string = response.data.mystring;
        });
    };
    $scope.generatorPost = function() {
        var data = {length:3};
        $http.post(url, JSON.stringify(data), http_config).then( function(response) {
            $scope.generated_string = response.data.mystring;
        });
    };
    $scope.generatorPut = function() {
        var data = {another_string: $scope.toput};
        $http.put(url,  JSON.stringify(data), http_config).then( function(response) {
            $scope.generated_string = response.data.mystring;
        });
    };
    $scope.generatorDelete = function() {
        $http.delete(url, http_config).then( function(response) {
            $scope.generated_string = response.data.mystring;
        });
    };
 })
</script>

</html>